 
// +----------------------------------------------------------------------------------------+ //
// |                                      !FT DAILYANGLES  \/                              | //
// |                            Knowledge of the ancients ( )                             | //
// |_________________________________________________o0o___(_)___o0o________________________| //
// |_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|_____|____|_____| //
// |                                                                                   2011 | //
// |----------------------------------------------------------------------------------------| //
// | Programming language:     MQL4                                                         | //
// | Development platform:     MetaTrader 4                                                 | //
// |          End product:     Indicator for MetaTrader 4 designed                          | //
// |                           for Build 229 (current version)                              | //
// +----------------------------------------------------------------------------------------+ //

#property indicator_chart_window

// ------------------------------------------------------------------------------------------ //
//                            E X T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

extern int     DailyCandlesBack  = 10;

extern double  AngleUp           = 37.5,
               AngleDown         = 37.5;      
extern color   AngleUpColor      = C'40,80,160',
               AngleDownColor    = C'40,80,160';
extern int     Width             = 1;

// ------------------------------------------------------------------------------------------ //
//                            I N T E R N A L   V A R I A B L E S                             //
// ------------------------------------------------------------------------------------------ //

datetime       NewBar            = 0;

// ------------------------------------------------------------------------------------------ //
//                             I N I T I A L I S A T I O N                                    //
// ------------------------------------------------------------------------------------------ //

int init() {
   return;
}
 
void DeleteObjects() {
   for (int i=ObjectsTotal()-1;i>=0;i--)
      if (StringFind(ObjectName(i),"Angle")>-1) ObjectDelete(ObjectName(i));
   return;
}
 
// ------------------------------------------------------------------------------------------ //
//                            D E - I N I T I A L I S A T I O N                               //
// ------------------------------------------------------------------------------------------ //

int deinit() {
   DeleteObjects();
   return(0);
}

// ------------------------------------------------------------------------------------------ //
//                                M A I N   P R O C E D U R E                                 //
// ------------------------------------------------------------------------------------------ //

int start() {

   if (NewBar!=iTime(NULL,PERIOD_D1,0)) {
      int x=0,y=0,zh=0,zl=0;
      DeleteObjects();
      NewBar=iTime(NULL,PERIOD_D1,0);
      for (int i=0;i<=DailyCandlesBack;i++) {
         x=iBarShift(NULL,0,iTime(NULL,PERIOD_D1,i));
         y=iBarShift(NULL,0,iTime(NULL,PERIOD_D1,i+1));
         zh=iHighest(NULL,0,MODE_HIGH,y-x,x);
         zl=iLowest(NULL,0,MODE_LOW,y-x,x);
         //Print("i=",i," y=",y);
         if (zh<Bars) DrawAngles(zh,true);
         if (zl<Bars) DrawAngles(zl,false);
         }
      }
   x=iBarShift(NULL,0,iTime(NULL,PERIOD_D1,0));
   zh=iHighest(NULL,0,MODE_HIGH,x,0);
   zl=iLowest(NULL,0,MODE_LOW,x,0);
   string name="AngleUpCurr";
   if (ObjectFind(name)<0) {
      ObjectCreate(name,OBJ_TRENDBYANGLE,0,Time[zl],Low[zl]);
      ObjectSet(name,OBJPROP_ANGLE,AngleUp);
      ObjectSet(name,OBJPROP_COLOR,AngleUpColor);
      ObjectSet(name,OBJPROP_WIDTH,Width);
      ObjectSet(name,OBJPROP_RAY,true);
      ObjectSet(name,OBJPROP_BACK,true);
      }
   else ObjectMove(name,0,Time[zl],Low[zl]);
   name="AngleDownCurr";
   if (ObjectFind(name)<0) {
      ObjectCreate(name,OBJ_TRENDBYANGLE,0,Time[zh],High[zh]);
      ObjectSet(name,OBJPROP_ANGLE,-AngleDown);
      ObjectSet(name,OBJPROP_COLOR,AngleDownColor);
      ObjectSet(name,OBJPROP_WIDTH,Width);
      ObjectSet(name,OBJPROP_RAY,true);
      ObjectSet(name,OBJPROP_BACK,true);
      }
   else ObjectMove(name,0,Time[zh],High[zh]);
   return(0);
}

// ------------------------------------------------------------------------------------------ //
//                                   V O I D   S E C T I O N                                  //
// ------------------------------------------------------------------------------------------ //

void DrawAngles(int i, bool hi) {
   string name = "AngleUp:"+Time[i];
   if (!hi) {
      ObjectCreate(name,OBJ_TRENDBYANGLE,0,Time[i],Low[i]);
      ObjectSet(name,OBJPROP_ANGLE,AngleUp);
      ObjectSet(name,OBJPROP_COLOR,AngleUpColor);
      ObjectSet(name,OBJPROP_WIDTH,Width);
      ObjectSet(name,OBJPROP_RAY,true);
      ObjectSet(name,OBJPROP_BACK,true);
      }
   else {
      name="AngleDown:"+Time[i];
      ObjectCreate(name,OBJ_TRENDBYANGLE,0,Time[i],High[i]);
      ObjectSet(name,OBJPROP_ANGLE,-AngleDown);
      ObjectSet(name,OBJPROP_COLOR,AngleDownColor);
      ObjectSet(name,OBJPROP_WIDTH,Width);
      ObjectSet(name,OBJPROP_RAY,true);
      ObjectSet(name,OBJPROP_BACK,true);
      }
   return;
}
// ------------------------------------------------------------------------------------------ //
//                                     E N D   P R O G R A M                                  //
// ------------------------------------------------------------------------------------------ //
/*
                                                            
                                                          
                              ud$$$**$$$$$$$bc.                          
                          u@**"        4$$$$$$$Nu                       
                        J                ""#$$$$$$r                     
                       @                       $$$$b                    
                     .F                        ^*3$$$                   
                    :% 4                         J$$$N                  
                    $  :F                       :$$$$$                  
                   4F  9                       J$$$$$$$                 
                   4$   k             4$$$$bed$$$$$$$$$                 
                   $$r  'F            $$$$$$$$$$$$$$$$$r                
                   $$$   b.           $$$$$$$$$$$$$$$$$N                
                   $$$$$k 3eeed$$b    XARD777."$$$$$$$$$                
    .@$**N.        $$$$$" $$$$$$F'L $$$$$$$$$$$  $$$$$$$                
    :$$L  'L       $$$$$ 4$$$$$$  * $$$$$$$$$$F  $$$$$$F         edNc   
   @$$$$N  ^k      $$$$$  3$$$$*%   $F4$$$$$$$   $$$$$"        d"  z$N  
   $$$$$$   ^k     '$$$"   #$$$F   .$  $$$$$c.u@$$$          J"  @$$$$r 
   $$$$$$$b   *u    ^$L            $$  $$$$$$$$$$$$u@       $$  d$$$$$$ 
    ^$$$$$$.    "NL   "N. z@*     $$$  $$$$$$$$$$$$$P      $P  d$$$$$$$ 
       ^"*$$$$b   '*L   9$E      4$$$  d$$$$$$$$$$$"     d*   J$$$$$r   
            ^$$$$u  '$.  $$$L     "#" d$$$$$$".@$$    .@$"  z$$$$*"     
              ^$$$$. ^$N.3$$$       4u$$$$$$$ 4$$$  u$*" z$$$"          
                '*$$$$$$$$ *$b      J$$$$$$$b u$$P $"  d$$P             
                   #$$$$$$ 4$ 3*$"$*$ $"$'c@@$$$$ .u@$$$P               
                     "$$$$  ""F~$ $uNr$$$^&J$$$$F $$$$#                 
                       "$$    "$$$bd$.$W$$$$$$$$F $$"                   
                         ?k         ?$$$$$$$$$$$F'*                     
                          9$$bL     z$$$$$$$$$$$F                       
                           $$$$    $$$$$$$$$$$$$                        
                            '#$$c  '$$$$$$$$$"                          
                             .@"#$$$$$$$$$$$$b                          
                           z*      $$$$$$$$$$$$N.                       
                         e"      z$$"  #$$$k  '*$$.                     
                     .u*      u@$P"      '#$$c   "$$c                   
              u@$*"""       d$$"            "$$$u  ^*$$b.               
            :$F           J$P"                ^$$$c   '"$$$$$$bL        
           d$$  ..      @$#                      #$$b         '#$       
           9$$$$$$b   4$$                          ^$$k         '$      
            "$$6""$b u$$                             '$    d$$$$$P      
              '$F $$$$$"                              ^b  ^$$$$b$       
               '$W$$$$"                                'b@$$$$"         
                                                        ^$$$*  
*/     